(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material/select'), require('rxjs'), require('rxjs/operators'), require('@angular/cdk/layout'), require('@angular/router'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngx-mat-select', ['exports', '@angular/core', '@angular/common', '@angular/material/select', 'rxjs', 'rxjs/operators', '@angular/cdk/layout', '@angular/router', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-mat-select'] = {}, global.ng.core, global.ng.common, global.ng.material.select, global.rxjs, global.rxjs.operators, global.ng.cdk.layout, global.ng.router, global.ng.forms));
}(this, (function (exports, i0, common, select, rxjs, operators, layout, router, forms) { 'use strict';

    var NgxMatSelectConfigs = /** @class */ (function () {
        function NgxMatSelectConfigs() {
            this.emptyLabel = 'No results found';
            this.searchBoxPlaceholder = 'Search ...';
            // selectedItemsLabel: string = "Selected Item(s)";
            this.maximumResultForShow = 30;
            this.valueMember = 'id';
            this.displayMember = 'name';
            this.maxWidthForMobileView = 599.9;
            this.useMobileView = true;
            this.mobileViewType = 'FullScreen';
        }
        return NgxMatSelectConfigs;
    }());
    var NGX_MAT_SELECT_CONFIGS = new i0.InjectionToken('NGX_MAT_SELECT_CONFIGS');

    var NgxMatSelectService = /** @class */ (function () {
        function NgxMatSelectService(_configs) {
            this.configs = Object.assign(new NgxMatSelectConfigs(), _configs);
        }
        return NgxMatSelectService;
    }());
    NgxMatSelectService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgxMatSelectService_Factory() { return new NgxMatSelectService(i0.ɵɵinject(NGX_MAT_SELECT_CONFIGS, 8)); }, token: NgxMatSelectService, providedIn: "root" });
    NgxMatSelectService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgxMatSelectService.ctorParameters = function () { return [
        { type: NgxMatSelectConfigs, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [NGX_MAT_SELECT_CONFIGS,] }] }
    ]; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var NgxMatSelectMediaTracker = /** @class */ (function () {
        function NgxMatSelectMediaTracker(injector) {
            var _this = this;
            this._mobileQueryListener = function () {
                if (_this.onChangeMediaTracker)
                    _this.onChangeMediaTracker();
            };
            this.configs = injector.get(NgxMatSelectService).configs;
            this.media = injector.get(layout.MediaMatcher);
            this.platformId = injector.get(i0.PLATFORM_ID);
            if (common.isPlatformBrowser(this.platformId)) {
                this._mobileQueryListener();
            }
        }
        NgxMatSelectMediaTracker.prototype.ngOnDestroy = function () {
            if (common.isPlatformBrowser(this.platformId)) {
                this.mobileQuery.removeListener(this._mobileQueryListenerFunc);
            }
        };
        NgxMatSelectMediaTracker.prototype.ngOnInit = function () {
            if (common.isPlatformBrowser(this.platformId)) {
                this.mobileQuery = this.media.matchMedia('(max-width: ' + this.configs.maxWidthForMobileView + 'px)');
                this._mobileQueryListenerFunc = this._mobileQueryListener.bind(this);
                this.mobileQuery.addListener(this._mobileQueryListenerFunc);
                this.onChangeMediaTracker();
            }
        };
        return NgxMatSelectMediaTracker;
    }());
    NgxMatSelectMediaTracker.decorators = [
        { type: i0.Directive }
    ];
    NgxMatSelectMediaTracker.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };

    var NgxMatSelectDirective = /** @class */ (function (_super) {
        __extends(NgxMatSelectDirective, _super);
        function NgxMatSelectDirective(injector) {
            var _this = _super.call(this, injector) || this;
            _this.injector = injector;
            _this._lastSourceLen = 0;
            _this.lazyLoad = false;
            _this.source = [];
            _this.filteredSourceChange = new i0.EventEmitter();
            _this.filteredSource = [];
            _this.isStringArray = false;
            _this.fragment = 'search';
            _this.hasSearchBox = true;
            _this._isFirstLoading = false;
            _this._pageNumber = 1;
            _this._hasMoreRow = true;
            _this.searchValue = '';
            _this._htmlScrollTop = 0;
            _this._htmlScrollLeft = 0;
            _this._bodyScrollTop = 0;
            _this._bodyScrollLeft = 0;
            _this.loadingContainer = "<div class=\"ngx-mat-select-loading-container\"><div class=\"loadingio-spinner-ellipsis-ao6bq46b8nt\"><div class=\"ldio-it58uqzfg5\">\n  <div></div><div></div><div></div><div></div><div></div>\n</div></div></div>";
            _this.loadingScrollContainer = "<div class=\"loadingio-spinner-rolling-2vwh2v284qu\"><div class=\"ldio-o6nze7by54l\">\n                                                                                <div></div>\n                                                                                       </div></div>";
            _this.onChangeMediaTracker = function () {
                _this._changeMedia();
            };
            _this._scrollProcess = false;
            _this._preventKeyCodeList = [37, 38, 39, 40, 16];
            _this.deviceType = function () {
                var ua = navigator.userAgent;
                if (/(tablet|ipad|playbook|silk)|(android(?!.*mobi))/i.test(ua)) {
                    return 'tablet';
                }
                else if (/Mobile|Android|iP(hone|od)|IEMobile|BlackBerry|Kindle|Silk-Accelerated|(hpw|web)OS|Opera M(obi|ini)/.test(ua)) {
                    return 'mobile';
                }
                return 'desktop';
            };
            _this.matSelect = injector.get(select.MatSelect);
            _this._openPanelSub = _this.matSelect._openedStream.subscribe(_this._afterOpen.bind(_this));
            _this._currentEl = injector.get(i0.ElementRef).nativeElement;
            _this.router = injector.get(router.Router, null);
            _this.route = injector.get(router.ActivatedRoute, null);
            setTimeout(function () {
                _this._handleValueChanges();
            });
            return _this;
        }
        NgxMatSelectDirective.prototype.setloading = function (check) {
            var _this = this;
            if (this._listBoxEl) {
                var icon = this._listBoxEl.querySelector('.ngx-mat-select-search-box-icon');
                var loading = this._listBoxEl.querySelector('.ngx-mat-select-loading-container');
                if (check) {
                    icon.style.display = 'none';
                    loading.style.display = 'flex';
                }
                else {
                    icon.style.display = 'block';
                    loading.style.display = 'none';
                }
                if (this._mainLoadingElement) {
                    var el_1 = this._getListMainContainerElement();
                    if (check) {
                        el_1.scrollTo({
                            top: 0,
                        });
                        this._mainLoadingElement.style.display = 'block';
                        el_1.style.overflow = 'hidden';
                    }
                    else {
                        setTimeout(function () {
                            el_1.style.overflow = 'auto';
                            _this._mainLoadingElement.style.display = 'none';
                        }, 100);
                    }
                }
            }
        };
        NgxMatSelectDirective.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this._populateConfigs();
            this._closePanelSub = this.matSelect._closedStream.subscribe(this._afterClose.bind(this));
        };
        NgxMatSelectDirective.prototype.ngAfterViewInit = function () {
            var _this = this;
            setTimeout(function () {
                _this._bindAfterClick();
            }, 50);
            if (this.useMobileView) {
                this._changeMedia();
            }
            this.matSelect.compareWith = function (o1, o2) {
                if (o1 && o2) {
                    if (typeof o1 === 'object') {
                        return o1[_this.valueMember] === o2[_this.valueMember];
                    }
                    else {
                        return o1 === o2;
                    }
                }
            };
            if (this.inFirstLoadCallSearcher &&
                this.searcher &&
                typeof this.searcher === 'function') {
                this._isFirstLoading = true;
                this.searchValue = this.inFirstLoadSearcherValue;
                try {
                    this._onSearch()
                        .then(function (res) {
                        _this.source = res;
                        _this._isFirstLoading = false;
                        _this.searchValue = '';
                    })
                        .catch(function () {
                        _this._isFirstLoading = false;
                        _this.searchValue = '';
                    });
                }
                catch (_a) {
                    this._isFirstLoading = false;
                    this.searchValue = '';
                }
            }
        };
        NgxMatSelectDirective.prototype._checkIsFirstLoading = function () {
            var _this = this;
            setTimeout(function () {
                if (_this._isFirstLoading) {
                    _this._checkIsFirstLoading();
                }
                else {
                    setTimeout(function () {
                        _this.setloading(false);
                        _this._changeSearchBoxEnableStatus(true);
                    }, 250);
                }
            }, 150);
        };
        NgxMatSelectDirective.prototype.ngOnDestroy = function () {
            _super.prototype.ngOnDestroy.call(this);
            if (this._openPanelSub)
                this._openPanelSub.unsubscribe();
            if (this._closePanelSub) {
                this._closePanelSub.unsubscribe();
            }
            if (this._selectionChangeSub) {
                this._selectionChangeSub.unsubscribe();
            }
            if (this._inputSubscription) {
                this._inputSubscription.unsubscribe();
            }
            if (this._valueChangeSub) {
                this._valueChangeSub.unsubscribe();
            }
            if (this._valueChangeSub) {
                this._valueChangeSub.unsubscribe();
            }
            if (this.matSelectEl) {
                this.matSelectEl.removeEventListener('click', this.clickMatSelectFunc);
            }
        };
        NgxMatSelectDirective.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (changes.source && changes.source.currentValue) {
                setTimeout(function () {
                    if (changes.source.firstChange) {
                        _this._populateConfigs();
                    }
                    _this._init();
                });
            }
        };
        NgxMatSelectDirective.prototype.onPopState = function (event) {
            var _a;
            (_a = this.matSelect) === null || _a === void 0 ? void 0 : _a.close();
        };
        NgxMatSelectDirective.prototype.onClick = function (event) {
            var _this = this;
            if (!this.matSelect.panelOpen && this.filteredSource.length == 0) {
                this._addNullKeyToOption();
                setTimeout(function () {
                    _this.matSelect.open();
                    _this._cleanNullKeyToOption();
                });
            }
        };
        NgxMatSelectDirective.prototype._populateConfigs = function () {
            var _a, _b;
            if (this.emptyLabel === undefined) {
                this.emptyLabel = this.configs.emptyLabel;
            }
            if (this.searchBoxPlaceholder === undefined) {
                this.searchBoxPlaceholder = this.configs.searchBoxPlaceholder;
            }
            if (this.maximumResultForShow === undefined) {
                this.maximumResultForShow = this.configs.maximumResultForShow;
            }
            if (this.useMobileView === undefined || this.useMobileView == null) {
                this.useMobileView = this.configs.useMobileView;
            }
            if (!this.mobileViewType) {
                this.mobileViewType = this.configs.mobileViewType;
            }
            if (!this.valueMember) {
                this.valueMember = this.configs.valueMember;
            }
            if (!this.displayMember) {
                this.displayMember = this.configs.displayMember;
            }
            if (!this.noMoreResultLabel) {
                this.noMoreResultLabel = this.configs.noMoreResultLabel;
                if (!this.noMoreResultLabel) {
                    this.noMoreResultLabel = 'No more results found';
                }
            }
            if (this.useInfiniteScroll === undefined ||
                this.useInfiniteScroll === null) {
                this.useInfiniteScroll = this.configs.useInfiniteScroll;
            }
            if (this.inFirstLoadCallSearcher === undefined ||
                this.inFirstLoadCallSearcher === null) {
                this.inFirstLoadCallSearcher = this.configs.inFirstLoadCallSearcher;
            }
            if (this.inFirstLoadSearcherValue === undefined ||
                this.inFirstLoadSearcherValue == null) {
                this.inFirstLoadSearcherValue = (_a = this.configs.inFirstLoadSearcherValue) !== null && _a !== void 0 ? _a : '';
            }
            (_b = this._clickableEl) === null || _b === void 0 ? void 0 : _b.removeEventListener('click', this._afterClickFunc);
        };
        NgxMatSelectDirective.prototype._bindAfterClick = function () {
            this._afterClickFunc = this.onClick.bind(this);
            var parentEl = this._currentEl.parentElement.parentElement.parentElement.parentElement;
            if (parentEl.tagName == 'MAT-FORM-FIELD') {
                this._clickableEl = parentEl;
                parentEl.addEventListener('click', this._afterClickFunc);
            }
            else {
                this._currentEl.addEventListener('click', this._afterClickFunc);
                this._clickableEl = this._currentEl;
            }
        };
        NgxMatSelectDirective.prototype._handleValueChanges = function () {
            var _this = this;
            var ngModelChanges = this.injector.get(forms.NgModel, null);
            if (ngModelChanges) {
                this._valueChangeSub = ngModelChanges.valueChanges.subscribe(function (val) {
                    if (val)
                        _this._valueChangeDetected();
                });
            }
            else {
                var formControlValueChange = this.injector.get(forms.FormControlName, null);
                if (formControlValueChange) {
                    this._valueChangeSub = formControlValueChange.valueChanges.subscribe(function (val) {
                        if (val)
                            _this._valueChangeDetected();
                    });
                }
                else {
                    this._valueChangeSub = this.matSelect.valueChange.subscribe(function (val) {
                        if (val)
                            _this._valueChangeDetected();
                    });
                }
            }
        };
        NgxMatSelectDirective.prototype._valueChangeDetected = function () {
            var _this = this;
            if (!this.matSelect.panelOpen) {
                this._fromSearch = false;
                if (this.searchValue) {
                    this.searchValue = '';
                }
                this._syncValueAndOptions();
                setTimeout(function () {
                    _this._syncSourceAndOptions(_this.filteredSource);
                });
            }
        };
        NgxMatSelectDirective.prototype._addLoadingElementForScrollInf = function () {
            var container = document.createElement('div');
            container.classList.add('ngx-mat-select-scroll-loading');
            container.innerHTML = this.loadingScrollContainer;
            this._scrollInfLoadingEl = container;
            this._listBoxEl.parentElement.appendChild(container);
        };
        NgxMatSelectDirective.prototype.changeScrollLoadingState = function (show) {
            if (this._scrollInfLoadingEl) {
                if (show) {
                    this._changeSearchBoxEnableStatus(false);
                    this._scrollInfLoadingEl.style.display = 'block';
                }
                else {
                    this._scrollInfLoadingEl.style.display = 'none';
                    this._changeSearchBoxEnableStatus(true);
                }
            }
        };
        NgxMatSelectDirective.prototype._addMainLoading = function () {
            var el = document.createElement('div');
            el.classList.add('ngx-mat-select-main-loading');
            el.innerHTML = this.loadingScrollContainer;
            this._mainLoadingElement = el;
            this._listBoxEl.appendChild(el);
        };
        NgxMatSelectDirective.prototype.scrollInfChange = function (event) {
            var _this = this;
            var el = event.target;
            if (el) {
                var scrollTop = el.scrollTop;
                var scrollHeight = el.scrollHeight;
                var height = el.clientHeight;
                if (scrollTop + height + 20 >= scrollHeight &&
                    !this._scrollProcess &&
                    this._hasMoreRow) {
                    this._scrollProcess = true;
                    var checkSourceLen = this.source.length || this._lastSourceLen;
                    if (checkSourceLen < this.maximumResultForShow) {
                        this._hasMoreRow = false;
                        this._scrollProcess = false;
                    }
                    else {
                        this.changeScrollLoadingState(true);
                        setTimeout(function () {
                            _this._listBoxEl.scrollTo({
                                top: _this._listBoxEl.scrollHeight,
                            });
                            setTimeout(function () {
                                _this._pageNumber += 1;
                                _this._onSearch(true).then(function (items) {
                                    _this._lastSourceLen = items.length;
                                    var len = items.length;
                                    _this._hasMoreRow = len >= _this.maximumResultForShow;
                                    _this.changeScrollLoadingState(false);
                                    items.forEach(function (z) {
                                        z['ngxPage'] = _this._pageNumber;
                                        z.ngxHide = false;
                                    });
                                    var pagedSrc = __spread(_this.filteredSource.filter(function (w) { return !w['ngxPage'] || w['ngxPage'] != _this._pageNumber; }), items);
                                    _this._syncSourceAndOptions(pagedSrc.filter(function (w) { return !w.ngxHide; }), _this._pageNumber * _this.maximumResultForShow, pagedSrc);
                                    if (!_this._hasMoreRow) {
                                        _this._changeNoMoreResultState(true);
                                        _this._scrollToNextItem();
                                    }
                                    else {
                                        _this._scrollToNextItem();
                                    }
                                    _this._scrollProcess = false;
                                });
                            }, 350);
                        }, 0);
                    }
                }
            }
        };
        NgxMatSelectDirective.prototype._addScrollInf = function () {
            this.scrollInfFunc = this.scrollInfChange.bind(this);
            var el = this._getListMainContainerElement();
            el === null || el === void 0 ? void 0 : el.addEventListener('scroll', this.scrollInfFunc, false);
            this._addLoadingElementForScrollInf();
        };
        NgxMatSelectDirective.prototype._changeNoMoreResultState = function (show) {
            if (this._noMoreResultEl) {
                if (!show) {
                    this._noMoreResultEl.style.display = 'none';
                }
                else {
                    this._noMoreResultEl.style.display = 'block';
                }
            }
        };
        NgxMatSelectDirective.prototype._scrollToNextItem = function () {
            var _a, _b, _c;
            var el = this._getListMainContainerElement();
            var optionHeight = (_c = (_b = (_a = this.matSelect) === null || _a === void 0 ? void 0 : _a.options) === null || _b === void 0 ? void 0 : _b.first._getHostElement().clientHeight) !== null && _c !== void 0 ? _c : 34;
            this._scrollInList(el.scrollTop + optionHeight);
        };
        NgxMatSelectDirective.prototype._scrollToEndOfList = function () {
            var el = this._getListMainContainerElement();
            this._scrollInList(el.scrollHeight);
        };
        NgxMatSelectDirective.prototype._scrollInList = function (top) {
            var el = this._getListMainContainerElement();
            if (el) {
                setTimeout(function () {
                    el.scrollTo({
                        top: top,
                        behavior: 'smooth',
                    });
                });
            }
        };
        NgxMatSelectDirective.prototype._getListMainContainerElement = function () {
            var el;
            if (this.mobileQuery.matches && this.useMobileView) {
                el = this._listBoxEl.parentElement;
            }
            else {
                el = this._listBoxEl;
            }
            return el;
        };
        NgxMatSelectDirective.prototype._addNoMoreResultElement = function () {
            if (this._listBoxEl) {
                var container = document.createElement('div');
                container.classList.add('ngx-mat-select-scroll-no-more');
                container.innerText = this.noMoreResultLabel;
                this._noMoreResultEl = container;
                this._listBoxEl.appendChild(container);
            }
        };
        NgxMatSelectDirective.prototype._removeScrollInfEvent = function () {
            var el = this._getListMainContainerElement();
            if (el) {
                el.removeEventListener('scroll', this.scrollInfFunc);
            }
        };
        NgxMatSelectDirective.prototype._changeSearchBoxEnableStatus = function (enable) {
            if (this._searchBoxInputEl) {
                if (enable) {
                    this._searchBoxInputEl.removeAttribute('disabled');
                }
                else {
                    this._searchBoxInputEl.setAttribute('disabled', 'disabled');
                }
            }
        };
        NgxMatSelectDirective.prototype._cleanNullKeyToOption = function () {
            var index = this.filteredSource.findIndex(function (z) { return z.keyNull == 'null'; });
            if (index >= 0) {
                this.filteredSource.splice(index, 1);
                if (this.filteredSource.length == 0) {
                    this._syncSourceAndOptions(this.filteredSource);
                }
                else {
                    this.filteredSourceChange.emit(this.filteredSource);
                }
            }
        };
        NgxMatSelectDirective.prototype._addNullKeyToOption = function () {
            if (this.matSelect.options.length == 0) {
                this.filteredSource.push({ keyNull: 'null' });
                this.filteredSourceChange.emit(this.filteredSource);
            }
        };
        NgxMatSelectDirective.prototype._moveCursorToEnd = function (el) {
            if (typeof el.selectionStart == 'number') {
                el.selectionStart = el.selectionEnd = el.value.length;
            }
            else if (typeof el.createTextRange != 'undefined') {
                el.focus();
                var range = el.createTextRange();
                range.collapse(false);
                range.select();
            }
        };
        NgxMatSelectDirective.prototype._handleBackDropAfterClose = function () {
            var backdropEl = document.querySelector('.cdk-overlay-container.bottomToTop .cdk-overlay-backdrop');
            if (backdropEl) {
                backdropEl.style.display = 'none';
                backdropEl.parentElement.classList.remove('bottomToTop');
            }
        };
        NgxMatSelectDirective.prototype._handleOverflowAfterClose = function () {
            var _this = this;
            var _a;
            if (this.useMobileView) {
                if (this.mobileQuery.matches) {
                    document.documentElement.style.overflow = '';
                    setTimeout(function () {
                        document.documentElement.scrollTo(_this._htmlScrollLeft, _this._htmlScrollTop);
                    }, 0);
                    if (this.fragment) {
                        (_a = this.router) === null || _a === void 0 ? void 0 : _a.navigate([], { relativeTo: this.route, fragment: null });
                    }
                }
            }
        };
        NgxMatSelectDirective.prototype._handleSelectionAfterClose = function () {
            this._addNullKeyToOption();
        };
        NgxMatSelectDirective.prototype._addSearchablePanelClass = function (parent) {
            if (this._listBoxEl) {
                if (!parent.classList.contains('ngx-mat-select-panel')) {
                    parent.classList.add('ngx-mat-select-panel');
                }
            }
        };
        NgxMatSelectDirective.prototype._createHeaderElement = function () {
            this.timeOut = null;
            var searchElement = document.createElement('div');
            searchElement.innerHTML = "\n    <input type='text'\n\n     placeholder=\"" + this.searchBoxPlaceholder + "\"\n     class=\"ngx-mat-select-search-box-input\" value=\"" + this.searchValue + "\" >\n    <i class=\"ngx-mat-select-search-box-icon\"></i>\n    " + this.loadingContainer + "\n    ";
            searchElement.addEventListener('keydown', function (ev) {
                if ((ev === null || ev === void 0 ? void 0 : ev.keyCode) === 32) {
                    ev.stopImmediatePropagation();
                }
            });
            var inputContainerEl = document.createElement('div');
            inputContainerEl.classList.add('ngx-mat-select-search-box-wrap');
            inputContainerEl.appendChild(searchElement);
            searchElement.classList.add('ngx-mat-select-search-box-container');
            searchElement.classList.add('abs');
            if (!this.hasSearchBox) {
                if (this.mobileQuery.matches && this.useMobileView) {
                    searchElement.style.display = 'none';
                }
                else {
                    inputContainerEl.style.display = 'none';
                }
            }
            return inputContainerEl;
        };
        NgxMatSelectDirective.prototype._afterOpen = function () {
            var _this = this;
            if (!this.mobileQuery.matches || !this.useMobileView) {
                this._removeOpacity();
            }
            this._listBoxEl = this.matSelect.panel.nativeElement;
            setTimeout(function () {
                if (_this.useInfiniteScroll) {
                    _this._addScrollInf();
                    _this._addNoMoreResultElement();
                }
                _this._addMainLoading();
                if (_this._isFirstLoading) {
                    _this.setloading(true);
                    _this._changeSearchBoxEnableStatus(false);
                    _this._checkIsFirstLoading();
                }
            }, 10);
            if (this._listBoxEl) {
                if (this.hasSearchBox &&
                    !this.mobileQuery.matches &&
                    this.useMobileView) {
                    this._listBoxEl.style.height = this._panelMaxHeight + 'px';
                }
                var inputContainerEl_1 = this._createHeaderElement();
                this._listBoxEl.prepend(inputContainerEl_1);
                this._appendNotFoundHtmlTag();
                this._cleanNullKeyToOption();
                this._handleNotFoundLabel(this.filteredSource);
                if (this.useMobileView) {
                    this._afterOpenForMobile(inputContainerEl_1);
                }
                setTimeout(function () {
                    if (_this.hasSearchBox) {
                        var inputEl = inputContainerEl_1.querySelector('input');
                        _this._searchBoxInputEl = inputEl;
                        if (!_this.mobileQuery.matches || !_this.useMobileView) {
                            inputEl.focus();
                            _this._moveCursorToEnd(inputEl);
                        }
                        _this._handleObserverForInputValue(inputEl);
                    }
                });
            }
        };
        NgxMatSelectDirective.prototype._afterClose = function () {
            this._handleBackDropAfterClose();
            this._handleOverflowAfterClose();
            this._handleSelectionAfterClose();
            this._changeMedia();
            if (this.useInfiniteScroll) {
                this._removeScrollInfEvent();
                this._hasMoreRow = true;
            }
        };
        NgxMatSelectDirective.prototype._changePaging = function () {
            if (this._pageNumber > 1) {
                this._pageNumber = 1;
                this._syncSourceAndOptions(this.filteredSource.filter(function (w) { return !w.ngxHide; }), this.maximumResultForShow, this.filteredSource);
            }
        };
        NgxMatSelectDirective.prototype._handleObserverForInputValue = function (inputEl) {
            var _this = this;
            var terms$ = rxjs.fromEvent(inputEl, 'keyup').pipe(operators.map(function (event) {
                if (_this._checkKeyCode(event)) {
                    _this.setloading(true);
                    return event.target['value'];
                }
                else {
                    return event.target['value'];
                }
            }), operators.debounceTime(this.debounceTime()), operators.distinctUntilChanged());
            if (terms$) {
                this._inputSubscription = terms$ === null || terms$ === void 0 ? void 0 : terms$.subscribe(function (content) {
                    if (content !== undefined && content !== null) {
                        _this.searchValue = content;
                        _this._onSearch();
                    }
                });
            }
        };
        NgxMatSelectDirective.prototype._allowedKeyCode = function (keyCode) {
            return !this._preventKeyCodeList.includes(keyCode);
        };
        NgxMatSelectDirective.prototype.debounceTime = function () {
            return this.lazyLoad ? 400 : 250;
        };
        NgxMatSelectDirective.prototype._checkKeyCode = function (event) {
            if (this.deviceType() !== 'desktop') {
                return true;
            }
            if (event && event.keyCode !== null && event.keyCode !== undefined) {
                return this._allowedKeyCode(event.keyCode);
            }
            return true;
        };
        NgxMatSelectDirective.prototype._init = function () {
            var _this = this;
            if (this.hasSearchBox) {
                this._syncValueAndOptions();
                setTimeout(function () {
                    _this._syncSourceAndOptions(_this.filteredSource);
                }, 50);
            }
            else {
                this.filteredSource = this.source;
            }
        };
        NgxMatSelectDirective.prototype._syncValueAndOptions = function (mainSrc, maxCount) {
            var _this = this;
            if (mainSrc === void 0) { mainSrc = null; }
            if (maxCount === void 0) { maxCount = this.maximumResultForShow; }
            var src = this._setMaxCount(mainSrc || this.source, maxCount);
            this.value = this.matSelect.value;
            if (this.value) {
                var val_1 = this.value;
                if (Array.isArray(val_1)) {
                    if (val_1.length > 0) {
                        if (src.length > 0) {
                            val_1.forEach(function (v) {
                                var item = src.find(function (w) { return _this._getExp(w, v); });
                                if (!item) {
                                    if (v && typeof v === 'object') {
                                        src.unshift(v);
                                        v['ngxHide'] = true;
                                    }
                                    else {
                                        var nItem = _this.source.find(function (w) { return _this._getExp(w, v); });
                                        if (nItem) {
                                            src.unshift(nItem);
                                            nItem['ngxHide'] = true;
                                        }
                                    }
                                }
                                else {
                                    item['ngxHide'] = false;
                                }
                            });
                        }
                        else {
                            if (this.source.length == 0) {
                                this.source = val_1;
                            }
                            else {
                                val_1.forEach(function (item) { return (item['ngxHide'] = true); });
                            }
                            src = val_1;
                        }
                    }
                }
                else {
                    if (src.length > 0) {
                        var item = src.find(function (w) { return _this._getExp(w, val_1); });
                        if (!item) {
                            if (val_1 && typeof val_1 === 'object') {
                                val_1['ngxHide'] = true;
                                src.unshift(val_1);
                            }
                            else {
                                var nItem = this.source.find(function (w) { return _this._getExp(w, val_1); });
                                if (nItem) {
                                    nItem['ngxHide'] = true;
                                    src.unshift(nItem);
                                }
                            }
                        }
                        else {
                            item['ngxHide'] = false;
                        }
                    }
                    else if (val_1 && typeof val_1 === 'object') {
                        if (this.source.length == 0) {
                            this.source = [val_1];
                        }
                        else {
                            val_1['ngxHide'] = true;
                        }
                        src = [val_1];
                    }
                }
            }
            this.filteredSource = src;
            this.filteredSourceChange.emit(this.filteredSource);
        };
        NgxMatSelectDirective.prototype._syncSourceAndOptions = function (filteredSource, maxCount, mainSrc) {
            var _this = this;
            if (maxCount === void 0) { maxCount = this.maximumResultForShow; }
            if (mainSrc === void 0) { mainSrc = this.source; }
            filteredSource = this._setMaxCount(filteredSource, maxCount);
            filteredSource.forEach(function (item) { return (item['ngxSelected'] = 0); });
            this.matSelect.options.forEach(function (op) { return (op['_element'].nativeElement.style.display = ''); });
            var selectedOptionO = this.matSelect.selected;
            var selectedOptions = [];
            if (selectedOptionO) {
                if (!Array.isArray(selectedOptionO)) {
                    selectedOptions = [selectedOptionO];
                }
                else {
                    selectedOptions = selectedOptionO;
                }
                var unshiftedlist_1 = [];
                selectedOptions.forEach(function (option) {
                    var item = filteredSource.find(function (z) { return _this._getExpForOption(z, option.value); });
                    if (!item) {
                        if (option.value && typeof option.value === 'object') {
                            item = option.value;
                        }
                        else {
                            item = mainSrc.find(function (z) { return _this._getExpForOption(z, option.value); });
                        }
                        if (item) {
                            item['ngxSelected'] = 1;
                            item['ngxHide'] = true;
                            unshiftedlist_1.push(item);
                        }
                    }
                    else if (item['ngxHide']) {
                        if (_this._fromSearch) {
                            item['ngxHide'] = false;
                        }
                        else {
                            item['ngxHide'] = true;
                        }
                    }
                });
                filteredSource.unshift.apply(filteredSource, __spread(unshiftedlist_1));
            }
            var showNotFoundLabel = this._handleNotFoundLabel(filteredSource);
            if (showNotFoundLabel) {
                this._toggleParentClass(this.matSelect.panel, 'remove-options', '.cdk-overlay-pane');
            }
            else {
                this._toggleParentClass(this.matSelect.panel, 'hide-options', '.cdk-overlay-pane');
            }
            this.filteredSource = filteredSource;
            this.filteredSourceChange.emit(this.filteredSource);
            setTimeout(function () {
                _this._hideOptions();
                setTimeout(function () {
                    _this._removeParentClass(_this.matSelect.panel, 'hide-options', '.cdk-overlay-pane');
                    _this._removeParentClass(_this.matSelect.panel, 'remove-options', '.cdk-overlay-pane');
                }, 0);
            });
        };
        NgxMatSelectDirective.prototype._hideOptions = function () {
            var _this = this;
            this.filteredSource
                .filter(function (z) { return !!z['ngxHide']; })
                .forEach(function (hide) {
                var ops;
                if (!_this.matSelect.multiple) {
                    ops = [_this.matSelect.selected];
                }
                else {
                    ops = _this.matSelect.selected;
                }
                var option = ops.find(function (z) { return _this._getExpForOption(hide, z.value); });
                if (option) {
                    var opEl = option['_element'].nativeElement;
                    opEl.style.display = 'none';
                }
            });
        };
        NgxMatSelectDirective.prototype._getPagedResult = function (src) {
            var result = [];
            var startIndex = this.maximumResultForShow * (this._pageNumber - 1);
            var endIndex = this.maximumResultForShow * this._pageNumber;
            if (endIndex > src.length) {
                endIndex = src.length;
            }
            var len = src.length;
            if (startIndex <= len) {
                result = src.slice(startIndex, endIndex);
            }
            return result;
        };
        NgxMatSelectDirective.prototype.refreshData = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                if (!_this.matSelect.panelOpen) {
                    _this._isFirstLoading = true;
                }
                else {
                    _this.setloading(true);
                    _this._changeSearchBoxEnableStatus(false);
                }
                try {
                    _this._onSearch()
                        .then(function (res) {
                        _this._isFirstLoading = false;
                        _this._changeSearchBoxEnableStatus(true);
                        _this.source = res;
                        resolve(res);
                    })
                        .catch(function () {
                        _this._isFirstLoading = false;
                        _this._changeSearchBoxEnableStatus(true);
                        reject();
                    });
                }
                catch (_a) {
                    _this._isFirstLoading = false;
                    _this._changeSearchBoxEnableStatus(true);
                    reject();
                }
            });
        };
        NgxMatSelectDirective.prototype._onSearch = function (changePage) {
            var _this = this;
            if (changePage === void 0) { changePage = false; }
            this._fromSearch = true;
            if (!changePage) {
                if (this._listBoxEl) {
                    this._listBoxEl.scrollTo({
                        top: 0,
                    });
                }
                this._pageNumber = 1;
                this._hasMoreRow = true;
                this._changeNoMoreResultState(false);
            }
            return new Promise(function (resolve, reject) {
                try {
                    _this._addSearchablePanelClass(_this._listBoxEl);
                    if (!_this.lazyLoad) {
                        var filteredSource = [];
                        if (_this.isStringArray) {
                            filteredSource = _this.source.filter(function (x) { return x === null || x === void 0 ? void 0 : x.toString().includes(_this.searchValue); });
                        }
                        else {
                            filteredSource = _this.source.filter(function (x) { var _a; return (_a = x[_this.displayMember]) === null || _a === void 0 ? void 0 : _a.toString().includes(_this.searchValue); });
                        }
                        if (!changePage) {
                            _this._syncSourceAndOptions(filteredSource);
                            _this.setloading(false);
                        }
                        else {
                            filteredSource = _this._getPagedResult(filteredSource);
                        }
                        resolve(filteredSource);
                    }
                    else {
                        if (_this.searcher && typeof _this.searcher === 'function') {
                            _this.searcher(_this.searchValue, _this._pageNumber, _this.maximumResultForShow)
                                .toPromise()
                                .then(function (res) {
                                if (!changePage) {
                                    _this._syncSourceAndOptions(res);
                                    _this.setloading(false);
                                }
                                resolve(res);
                            })
                                .catch(function () {
                                _this.setloading(false);
                                resolve(0);
                            });
                        }
                        else {
                            _this.setloading(false);
                            resolve(0);
                        }
                    }
                }
                catch (_a) {
                    resolve(0);
                }
            });
        };
        NgxMatSelectDirective.prototype._appendNotFoundHtmlTag = function () {
            var el = document.createElement('div');
            el.classList.add('ngx-mat-select-not-found-container');
            el.innerHTML = this.emptyLabel;
            this._listBoxEl.appendChild(el);
        };
        NgxMatSelectDirective.prototype._handleNotFoundLabel = function (filteredSource) {
            var show = filteredSource && filteredSource.length > 0
                ? filteredSource.filter(function (z) { return !z['ngxHide']; }).length == 0
                : true;
            if (this._listBoxEl) {
                var el = this._listBoxEl.querySelector('.ngx-mat-select-not-found-container');
                if (el) {
                    if (show) {
                        el.style.display = 'flex';
                    }
                    else {
                        el.style.display = 'none';
                    }
                }
            }
            return show;
        };
        NgxMatSelectDirective.prototype._setMaxCount = function (filteredSource, maxCount) {
            if (maxCount === void 0) { maxCount = this.maximumResultForShow; }
            if (maxCount) {
                filteredSource = filteredSource.slice(0, this._getMaxSize(filteredSource, maxCount));
            }
            return filteredSource;
        };
        NgxMatSelectDirective.prototype._getExp = function (left, right) {
            if (right[this.valueMember]) {
                return left[this.valueMember] == right[this.valueMember];
            }
            else {
                return left[this.valueMember] == right;
            }
        };
        NgxMatSelectDirective.prototype._getExpForOption = function (left, right) {
            if (left[this.valueMember]) {
                if (right[this.valueMember]) {
                    return left[this.valueMember] == right[this.valueMember];
                }
                else {
                    return left[this.valueMember] == right;
                }
            }
            else {
                return left == right;
            }
        };
        NgxMatSelectDirective.prototype._getMaxSize = function (arr, maximumCount) {
            if (!arr)
                return 0;
            var length = arr.length;
            return length > maximumCount ? maximumCount : length;
        };
        NgxMatSelectDirective.prototype._changeMedia = function () {
            var _a;
            var classes = (_a = this.matSelect.panelClass) === null || _a === void 0 ? void 0 : _a.toString().split(' ');
            if (!classes) {
                classes = [];
            }
            if (!classes.includes('ngx-mat-select-opacity')) {
                classes.push('ngx-mat-select-opacity');
            }
            if (this.mobileQuery.matches && this.useMobileView) {
                var hasMyClass = classes.includes('ngx-mat-select-mobile');
                if (this.matSelect) {
                    if (!hasMyClass) {
                        classes.push('ngx-mat-select-mobile');
                    }
                }
            }
            else {
                classes = classes.filter(function (z) { return z !== 'ngx-mat-select-mobile'; });
            }
            if (classes)
                this.matSelect.panelClass = classes.join(' ');
        };
        NgxMatSelectDirective.prototype._addTitleForMobileView = function (spacer) {
            if (spacer && !this.hasSearchBox) {
                var titleEl = document.createElement('div');
                titleEl.classList.add('ngx-mat-select-mobile-title');
                if (this.title)
                    titleEl.innerHTML = this.title;
                if (document.documentElement.dir === 'rtl') {
                    titleEl.style.right = '48px';
                }
                else {
                    titleEl.style.left = '48px';
                }
                spacer.style.display = 'block';
                spacer.prepend(titleEl);
            }
        };
        NgxMatSelectDirective.prototype._removeOpacity = function () {
            var _this = this;
            setTimeout(function () {
                _this._listBoxEl.classList.remove('ngx-mat-select-opacity');
            });
        };
        NgxMatSelectDirective.prototype._afterOpenForMobile = function (spacer) {
            var _this = this;
            var _a;
            this._htmlScrollTop = document.documentElement.scrollTop;
            this._htmlScrollLeft = document.documentElement.scrollLeft;
            var panel = this.matSelect.panel;
            var panelEl = panel.nativeElement;
            var parentEl = panelEl.parentElement;
            if (this.mobileQuery.matches) {
                document.documentElement.style.overflow = 'hidden';
                panelEl.classList.remove('mat-select-panel');
                if (this.hasSearchBox || this.title) {
                    var listEl = document.querySelector('.ngx-mat-select-mobile');
                    if (listEl) {
                        listEl.style.paddingTop = '50px';
                    }
                }
                this._addTitleForMobileView(spacer);
                setTimeout(function () {
                    _this._removeOpacity();
                }, 80);
                this._toggleParentClass(panel, 'ngx-mat-select-mobile-wrapper', '.cdk-overlay-pane');
                if (this.mobileViewType === 'BottomSheet') {
                    this._toggleParentClass(panel, 'bottomToTop', '.cdk-overlay-container');
                    this._toggleParentClass(panel, 'ngx-mat-select-mobile-open-bottomToTop', '.cdk-overlay-pane');
                }
                else {
                    this._toggleParentClass(panel, 'ngx-mat-select-mobile-open-fullScreen', '.cdk-overlay-pane');
                }
                parentEl.style.overflowY = 'auto';
                parentEl.style.overflowX = 'hidden';
                var firstSelected_1 = panelEl.querySelector('.mat-selected');
                setTimeout(function () {
                    firstSelected_1 === null || firstSelected_1 === void 0 ? void 0 : firstSelected_1.scrollIntoView({ block: 'center', behavior: 'smooth' });
                }, 500);
                if (this.hasSearchBox || this.title || true) {
                    var iconAppend = spacer;
                    var inputSearch = spacer.querySelector('.mat-select-search-input');
                    if (inputSearch)
                        inputSearch.style.padding = '0';
                    var btn = document.createElement('i');
                    if (document.documentElement.dir === 'rtl') {
                        btn.classList.add('arrow-right');
                    }
                    else {
                        btn.classList.add('arrow-left');
                    }
                    btn.onclick = function (ev) {
                        ev.stopImmediatePropagation();
                        _this.matSelect.close();
                    };
                    iconAppend.style.display = 'flex';
                    iconAppend.style.alignItems = 'center';
                    iconAppend.style.width = '100%';
                    iconAppend === null || iconAppend === void 0 ? void 0 : iconAppend.prepend(btn);
                }
                if (this.fragment) {
                    (_a = this.router) === null || _a === void 0 ? void 0 : _a.navigate([], {
                        relativeTo: this.route,
                        fragment: this.fragment,
                    });
                }
                spacer.style.position = 'fixed';
                setTimeout(function () {
                    spacer.style.position = '';
                }, 150);
            }
            else {
                if (!panelEl.classList.contains('mat-select-panel')) {
                    panel.nativeElement.classList.add('mat-select-panel');
                }
            }
        };
        NgxMatSelectDirective.prototype._toggleParentClass = function (el, className, targetSelect) {
            var _a;
            if ((_a = el === null || el === void 0 ? void 0 : el.nativeElement) === null || _a === void 0 ? void 0 : _a.parentElement) {
                var parentEl = el.nativeElement.parentElement.closest(targetSelect);
                if (parentEl) {
                    parentEl.classList.toggle(className, true);
                }
            }
        };
        NgxMatSelectDirective.prototype._removeParentClass = function (el, className, targetSelect) {
            var _a;
            if ((_a = el === null || el === void 0 ? void 0 : el.nativeElement) === null || _a === void 0 ? void 0 : _a.parentElement) {
                var parentEl = el.nativeElement.parentElement.closest(targetSelect);
                if (parentEl) {
                    parentEl.classList.remove(className);
                }
            }
        };
        return NgxMatSelectDirective;
    }(NgxMatSelectMediaTracker));
    NgxMatSelectDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: 'mat-select[ngxMatSelect]',
                    exportAs: 'ngxMatSelect',
                },] }
    ];
    NgxMatSelectDirective.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };
    NgxMatSelectDirective.propDecorators = {
        lazyLoad: [{ type: i0.Input }],
        source: [{ type: i0.Input }],
        filteredSourceChange: [{ type: i0.Output }],
        filteredSource: [{ type: i0.Input }],
        searcher: [{ type: i0.Input }],
        isStringArray: [{ type: i0.Input }],
        fragment: [{ type: i0.Input }],
        hasSearchBox: [{ type: i0.Input }],
        title: [{ type: i0.Input }],
        emptyLabel: [{ type: i0.Input }],
        searchBoxPlaceholder: [{ type: i0.Input }],
        maximumResultForShow: [{ type: i0.Input }],
        useMobileView: [{ type: i0.Input }],
        mobileViewType: [{ type: i0.Input }],
        valueMember: [{ type: i0.Input }],
        displayMember: [{ type: i0.Input }],
        value: [{ type: i0.Input }],
        noMoreResultLabel: [{ type: i0.Input }],
        useInfiniteScroll: [{ type: i0.Input }],
        inFirstLoadCallSearcher: [{ type: i0.Input }],
        inFirstLoadSearcherValue: [{ type: i0.Input }],
        onPopState: [{ type: i0.HostListener, args: ['window:popstate', ['$event'],] }]
    };

    var NgxMatSelectInitializer = /** @class */ (function () {
        function NgxMatSelectInitializer(injector) {
            var _this = this;
            this._mobileQueryListener = function () {
                if (_this.mobileQuery) {
                    _this._handleClasses(_this.mobileQuery.matches);
                }
            };
            this.media = injector.get(layout.MediaMatcher);
            this.platformId = injector.get(i0.PLATFORM_ID);
            this.configs = injector.get(NgxMatSelectService).configs;
            this.document = injector.get(common.DOCUMENT);
        }
        NgxMatSelectInitializer.prototype._handleClasses = function (matches) {
            if (matches) {
                if (!document.documentElement.classList.contains('ngx-mat-mobile')) {
                    document.documentElement.classList.add('ngx-mat-mobile');
                }
            }
            else {
                document.documentElement.classList.remove('ngx-mat-mobile');
            }
        };
        NgxMatSelectInitializer.prototype.init = function () {
            var _this = this;
            return function () {
                if (common.isPlatformServer(_this.platformId)) {
                    return rxjs.of(true).toPromise();
                }
                return new Promise(function (resolve, reject) {
                    if (window.screen.width <= _this.configs.maxWidthForMobileView) {
                        _this._mobileQueryListener();
                    }
                    _this.mobileQuery = _this.media.matchMedia('(max-width: '
                        + _this.configs.maxWidthForMobileView
                        + 'px)');
                    _this._mobileQueryListenerFunc = _this._mobileQueryListener.bind(_this);
                    _this.mobileQuery.addListener(_this._mobileQueryListenerFunc);
                    _this._handleClasses(_this.document.documentElement.clientWidth <= _this.configs.maxWidthForMobileView);
                    {
                        _this._handleClasses(_this.mobileQuery.matches);
                    }
                    resolve(true);
                });
            };
        };
        return NgxMatSelectInitializer;
    }());
    NgxMatSelectInitializer.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgxMatSelectInitializer_Factory() { return new NgxMatSelectInitializer(i0.ɵɵinject(i0.INJECTOR)); }, token: NgxMatSelectInitializer, providedIn: "root" });
    NgxMatSelectInitializer.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    NgxMatSelectInitializer.ctorParameters = function () { return [
        { type: i0.Injector }
    ]; };

    function nInit(ngxMatSelectInitializer) {
        return ngxMatSelectInitializer.init();
    }
    var NgxMatSelectModule = /** @class */ (function () {
        function NgxMatSelectModule() {
        }
        NgxMatSelectModule.forRoot = function (configs) {
            if (!configs) {
                configs = new NgxMatSelectConfigs();
            }
            else {
                configs = Object.assign(new NgxMatSelectConfigs(), configs);
            }
            return {
                ngModule: NgxMatSelectModule,
                providers: [
                    { provide: NGX_MAT_SELECT_CONFIGS, useValue: configs },
                    NgxMatSelectService,
                ]
            };
        };
        return NgxMatSelectModule;
    }());
    NgxMatSelectModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgxMatSelectDirective],
                    imports: [
                        common.CommonModule,
                    ],
                    providers: [
                        NgxMatSelectInitializer,
                        {
                            provide: i0.APP_INITIALIZER, deps: [NgxMatSelectInitializer],
                            useFactory: nInit,
                            multi: true
                        }
                    ],
                    exports: [
                        NgxMatSelectDirective,
                    ],
                },] }
    ];

    /*
     * Public API Surface of ngx-mat-select
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NGX_MAT_SELECT_CONFIGS = NGX_MAT_SELECT_CONFIGS;
    exports.NgxMatSelectConfigs = NgxMatSelectConfigs;
    exports.NgxMatSelectDirective = NgxMatSelectDirective;
    exports.NgxMatSelectInitializer = NgxMatSelectInitializer;
    exports.NgxMatSelectMediaTracker = NgxMatSelectMediaTracker;
    exports.NgxMatSelectModule = NgxMatSelectModule;
    exports.NgxMatSelectService = NgxMatSelectService;
    exports.nInit = nInit;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-mat-select.umd.js.map
